#include "problem4.hpp"
#include <iostream>

using namespace pe::problem4;

Problem4::Problem4(long maxlength) :
  INIT_LOGGER("problem4"),
  _maxlength(maxlength)
{
  LOG_DEBUG("Created problem4 engine.");
}

bool Problem4::isPalindrome(long number) {
  bool retval = false;
  LOG_DEBUG("Checking number " << number);
  std::vector<long> digits;
  while (number > 0) {
    long lastdigit = number % 10;
    digits.push_back(lastdigit);
    number = number / 10;
  }
  reverse(digits.begin(), digits.end());
  std::vector<long>::iterator front = digits.begin();
  std::vector<long>::iterator back = --digits.end();
  //printDebugDigits(digits);
  //LOG_DEBUG("1 Front: " << (*front));
  //LOG_DEBUG("1 Back: " << (*back));
  retval = false;
  while (! (front >= back)) {
    if ((*front) == (*back)) {
      retval = true;
      //printDebugDigits(digits);
      //LOG_DEBUG("2 Front: " << (*front));
      //LOG_DEBUG("2 Back: " << (*back));
      // move iterators to the next digits
      front++;
      back--;
    } else {
      // cannot be a palindrome, back out
      retval = false;
      break;
    }
  }
  return retval;
}

void Problem4::printDebugDigits(std::vector<long>& digits) {
  if (digits.empty()) {
    LOG_DEBUG("No digits left.");
  } else {
    std::vector<long>::iterator it;
    for(it = digits.begin(); it != digits.end(); it++) 
      std::cout << " " << (*it);
    std::cout << std::endl;
  }
}
